﻿local solQS_ADD_X = 45;
local solQS_ADD_Y = 45;
local solQS_OLD_X = 1;
local solQS_OLD_Y = 1;

function solQuickShifter_Update_Display()
	
	local forms = GetNumShapeshiftForms();
	for i=1, forms do
		_, name, active, castable = GetShapeshiftFormInfo(i);
		if( castable == nil or active ~= nil or name == nil  ) then
			if i == 1 then SQS_BTN_1:Hide(); end;
			if i == 2 then SQS_BTN_2:Hide(); end;
			if i == 3 then SQS_BTN_3:Hide(); end;
			if i == 4 then SQS_BTN_4:Hide(); end;
			if i == 5 then SQS_BTN_5:Hide(); end;
		else
			if i == 1 then SQS_BTN_1:Show(); end;
			if i == 2 then SQS_BTN_2:Show(); end;
			if i == 3 then SQS_BTN_3:Show(); end;
			if i == 4 then SQS_BTN_4:Show(); end;
			if i == 5 then SQS_BTN_5:Show(); end;		
		end
	end
end

function SQS_Shift(num)
	Chronos.unscheduleByName("solQuickShifter");
	solQuickShifterForm:Hide();
	if(num > 0) then
		CastShapeshiftForm(num)
	else
		SQS_deshift();
	end
end

function SQS_deshift()
	Chronos.unscheduleByName("solQuickShifter");
	solQuickShifterForm:Hide();
	local forms = GetNumShapeshiftForms();
	for i=1, forms do
		_, name, active = GetShapeshiftFormInfo(i);
		if( active ~= nil ) then
			DEFAULT_CHAT_FRAME:AddMessage("SQS: leaving '"..name.."'");
			CastShapeshiftForm(i)
			break;
		end
	end
end

function solQuickShifter_RePosition()
	local x,y = GetCursorPosition();
	if ( (x > solQS_OLD_X + 54 or x < solQS_OLD_X - 54) or (y > solQS_OLD_Y + 54 or y < solQS_OLD_Y - 54)  ) then
		solQuickShifterForm:SetPoint("TOPLEFT","UIParent","BOTTOMLEFT",x-solQS_ADD_X,y+solQS_ADD_Y);
		solQS_OLD_X = x; solQS_OLD_Y = y;
	end
	solQuickShifter_Update_Display();
end